import Foundation
import CoreLocation
import snowm_scanner

class BackgroundScannerResponse: SnowMBackgroundScanningServiceDelegate {

    static let shared = BackgroundScannerResponse()
    
    private var beaconBackgroundScanner = BackgroundBeaconScanner.shared
    private var notificaionHelper = NotificationHelper.shared

    private var timer: Timer?
    
    
    func onLocationUpdated(locations: [CLLocation]) {
        notificaionHelper.showNotification(message: "onLocationUpdated")
        beaconBackgroundScanner.startBeaconRanging()
    }
    
    func onBeaconDetected(beacons: [SnowMBeacon], customData: Dictionary<String, Any>?) {
        notificaionHelper.showNotification(message: "onBeaconDetected")
        if(timer == nil) {
            timer = Timer.init(timeInterval: 60, repeats: false) { (t) in
                self.notificaionHelper.showNotification(message: "onBeaconDetected after long time")
                self.timer?.invalidate()
                self.timer = nil
            }
        }
    }
    
    func onRegionEntered(region: CLBeaconRegion){
        notificaionHelper.showNotification(message: "onRegionEntered")
    }
    
    func onRegionExited(region: CLBeaconRegion){
        notificaionHelper.showNotification(message: "onRegionExited")
    }
    
    func didEnterGeofence(region: CLCircularRegion) {
        notificaionHelper.showNotification(message: "didEnterGeofence")
    }
    
    func didExitGeofence(region: CLCircularRegion) {
        notificaionHelper.showNotification(message: "didExitGeofence")
    }
    
}
